
' Segstart function to be run at the beginning of every Mission control Sequence segment calling this function

' The main routine has two calling methods available from STK.
' 1. Register - Which registers the inputs and outputs with STK
' 2. Computer - Perform the calculations and return the results to STK

' declare some global variables

' This is available globally

Dim g_saved_thrust
Dim g_saved_ISP
Dim g_saved_MassFlowRate

' ==========================================================================
' Main Routine
' The main routine has two calling methods available from STK.
' 1. Register - Which registers the inputs and outputs with STK
' 2. Compute - Perform the calculations and return the results to STK
' ==========================================================================


'==========================================================================
' Lunar_Descent_Model_SegStart fctn
'==========================================================================
Function Lunar_Descent_Model_SegStart( argArray )

	Dim retVal

	If IsEmpty(argArray(0)) Then

		' do compute

		retVal = Lunar_Descent_Model_SegStart_compute( argArray )

	ElseIf argArray(0) = "register" Then

		retVal = Lunar_Descent_Model_SegStart_register()

	ElseIf argArray(0) = "compute" Then

		' do compute

		retVal = Lunar_Descent_Model_SegStart_compute( argArray )

	Else

		' bad call

		retVal = Empty

	End If

	Lunar_Descent_Model_SegStart = retVal

End Function

' Register inputs and Outputs

Function Lunar_Descent_Model_SegStart_register()

	ReDim argStr(1), descripStr(3)

	descripStr(0)="ArgumentType = Input"
	descripStr(1)="Name = Epoch"
	descripStr(2)="ArgumentName = Epoch"

	argStr(0) = descripStr

	Lunar_Descent_Model_SegStart_register = argStr

End Function

'Calculate section

Function Lunar_Descent_Model_SegStart_compute(argArray)

'	Set this here so we always start off with a value

	g_saved_thrust = 44041.66515

	g_saved_ISP = 311.0
	g_saved_MassFlowRate = g_saved_thrust/(g_saved_ISP*9.80665)

End Function
