Dim Foo 'Declared in Eval Script

Dim Lunar_Descent_Model_Update_Inputs
Dim Lunar_Descent_Model_Update_Outputs


Dim FuzzyEng
Dim serr 
Dim ScenPath 

'==========================================================================
' Lunar_Descent_Model_Update() fctn
'==========================================================================
Function Lunar_Descent_Model_Update( argArray )

	Dim retVal

	If IsEmpty(argArray(0)) Then

		' do compute

		retVal = Lunar_Descent_Model_Update_compute( argArray )

	ElseIf argArray(0) = "register" Then

		Lunar_Descent_Model_Update_globalVar = -1

		retVal = Lunar_Descent_Model_Update_register()

	ElseIf argArray(0) = "compute" Then

		' do compute

		retVal = Lunar_Descent_Model_Update_compute( argArray )

	Else

		' bad call

		retVal = Empty

	End If


	Lunar_Descent_Model_Update = retVal

End Function

Function Lunar_Descent_Model_Update_register()

	ReDim descripStr(3), argStr(5)

	descripStr(0)="ArgumentType = Output"
	descripStr(1)="Name = Status"
	descripStr(2)="ArgumentName = status"

	argStr(0) = descripStr

	ReDim descripStr(3)

	descripStr(0)="ArgumentType = Input"
	descripStr(1)="Name = TotalMass"
	descripStr(2)="ArgumentName = Mass"

    	argStr(1) = descripStr

	ReDim descripStr(4)

	descripStr(0)="ArgumentType = Input"
	descripStr(1)="Name = Lunar_a_sub_t"
	descripStr(2)="ArgumentName = Lunar_a_sub_t"
	descripStr(3)="Type = CalcObject"

	argStr(2) = descripStr

	descripStr(0)="ArgumentType = Input"
	descripStr(1)="Name = Lunar_Altitude"
	descripStr(2)="ArgumentName = Lunar_Altitude"
	descripStr(3)="Type = CalcObject"

	argStr(3) = descripStr

	descripStr(0)="ArgumentType = Input"
	descripStr(1)="Name = Lunar_V_Fixed_Mag"
	descripStr(2)="ArgumentName = Lunar_V_Fixed_Mag"
	descripStr(3)="Type = CalcObject"

	argStr(4) = descripStr
	

	descripStr(0)="ArgumentType = Input"
	descripStr(1)="Name = Epoch"
	descripStr(2)="ArgumentName = Epoch"
	descripStr(3)="Type = CalcObject"

	argStr(5) = descripStr


	Lunar_Descent_Model_Update_register = argStr

	'Create COM object
	Set FuzzyEng = CreateObject("FuzzyLunarEngine.TVelocityModel")

	
	'Scenario path
	ScenPath = ""

	
	'Articulation File	
	FuzzyEng.ArticulationFile = true
	FuzzyEng.ArticulationFilePath = ScenPath  & "Lunar_Lander.sama"



	'Trace File to display Engione Thrust for Fuzzy Logic Output
	FuzzyEng.TraceFile = true
	FuzzyEng.TraceFilePath = ScenPath  & "FuzzyLander.csv"

	'Load Fuzzy System
   	If FuzzyEng.LoadFuzzySystem(ScenPath  & "LUNAR.ftr", serr) = False Then	
    		MsgBox serr
   	End If

	'Load Spacecraft Waypoints for proximity manuevers
	If FuzzyEng.LoadXMLWaypoints(ScenPath  & "LunarLanding.xml",serr) = false then
		MsgBox "Error Loading: " &  ScenPath  & "LandingWaypoints - " & serr
   	End If	


	

End Function


Function Lunar_Descent_Model_Update_compute( stateData)
	
' The following allow inputs and outputs to be called via c structure syntax

	Set Lunar_Descent_Model_Update_Inputs = g_GetPluginArrayInterface("Lunar_Descent_Model_Update_Inputs")
	Set Lunar_Descent_Model_Update_Outputs = g_GetPluginArrayInterface("Lunar_Descent_Model_Update_Outputs")

	
	Dim returnValue(4), thrust, ISP, mass, a_sub_t, target_accel, num_engines, altitude, velocity, variable, Epoch 
	Dim commanded_thrust, desiredThrust, maxThrustPossible, g      
       

	Epoch = stateData(Lunar_Descent_Model_Update_Inputs.Epoch)
	altitude  = stateData(Lunar_Descent_Model_Update_Inputs.Lunar_Altitude)	
	velocity = stateData(Lunar_Descent_Model_Update_Inputs.Lunar_V_Fixed_Mag)

	'Pass in Time
	FuzzyEng.EpochSecond = Epoch 

	g = 1.62 	   ' gravitational acelleration of moon 

	'Call Fuzzy Engine
	target_accel = FuzzyEng.FuzzyEngine((altitude  *  3.28) ,-(velocity    *  3.28), serr) 

	'Check for error condition in fuzzy logic engine
	if serr <> "" then 		
		FuzzyEng.TraceWriteline("Error FuzzyEngine " & serr)
	end if  

	'Calculate Thrust

	mass = stateData(Lunar_Descent_Model_Update_Inputs.Mass)

	'Max Thrust for this engine
	maxThrustPossible = 44041.66515 ' 9900 lbs Nominal thrust in N

	desiredThrust = (target_accel + g)*mass 

	
	if desiredThrust > maxThrustPossible then
	
		commanded_thrust = maxThrustPossible
	
	else
	
		commanded_thrust = desiredThrust
	End if

	'FuzzyEng.TraceWriteline("commanded_thrust = "  & commanded_thrust)
	
	                                                                   
	returnValue(Lunar_Descent_Model_Update_Outputs.status) = "Still Okay"
	g_saved_thrust = commanded_thrust
	g_saved_MassFlowRate = commanded_thrust/(g_saved_ISP*9.80665)

	Lunar_Descent_Model_Update_compute = returnValue

	
End Function

